clear all
close all
clc
y=imread('cameraman.tif');
info=imfinfo('cameraman.tif');
M=info.BitDepth;
G=2^M;

[m n]=size(y);
%%%%%%%Image Negative%%%%%%%%%%
for i=1:m
    for j=1:n
        z(i,j)=(G-1)-y(i,j);
    end
end 
figure
imshow(z)
title('image negative')
figure
imshow(y)
title('original image')

%%%%%%%%%%Contrast Stretching%%%%%%%%%%%
a=input('Enter the value of input graylevel r1 for contrast stretching:');
b=input('Enter the value of input graylevel r2 for contrast stretching:');
for i=1:m
    for j=1:n
        if y(i,j)<=a
            zz(i,j)=0.5*y(i,j);
        else if y(i,j)<=b
                zz(i,j)=2*(y(i,j)-a)+0.5*a;
            else 
                zz(i,j)=0.5*(y(i,j)-b)+0.5*a+2*(b-a);
            end
        end
    end
end
   figure
   imshow(zz)
   title('contrast stretched image')
   %%%%%%%%%%%% Thresholding%%%%%%%%%%%
   aa=input('Enter the threshold value for Basic Thresholding Point processing:');
   for i=1:m
       for j=1:n
           if y(i,j)<=aa
               zzz(i,j)=0;
           else zzz(i,j)=1;
           end
       end
   end
   
   figure
   imshow(zzz)
   title('thresholded image')
   %%%%%%%%%%%%Gray-level Sclicing%%%%%%%%%%%
   %%%%%%%%without back-ground
   aaa=input('enter the lower threshold value for graylevel slicing with/without background:');
   bbb=input('enter the upper threshold value for graylevel slicing with/without background:');
   
   for i=1:m
       for j=1:n
           if y(i,j)<= aaa
               zzzz(i,j)=0;
           else if y(i,j)<=bbb
                   zzzz(i,j)=1;
               else zzzz(i,j)=0;
               end 
           end
       end
   end
   %with back ground%%%
   for i=1:m
       for j=1:n
           if y(i,j)<= aaa
               zzzzz(i,j)=y(i,j);
           else if y(i,j)<=bbb
                   zzzzz(i,j)=255;
               else zzzzz(i,j)=y(i,j);
               end 
           end
       end
   end
   figure
   imshow(zzzz)
   title('graylevel slicing without back ground')
   figure
   imshow(zzzzz)
   title('graylevel sclicing with  background')
            



        